<template>
  <div>
    <BasicTable :clickToRowSelect="false" @register="registerTable" :searchInfo="searchInfo">
      <template #toolbar>
        <Authority value="api:yt:report_form:config:post">
          <a-button type="primary" @click="handleCreateOrEdit(null)"> 新增报表 </a-button>
        </Authority>
        <Authority value="api:yt:report:get">
          <a-button type="primary" @click="go('/report/export')"> 下载报表 </a-button>
        </Authority>
        <Authority value="api:yt:report_form:config:delete">
          <Popconfirm
            title="您确定要批量删除数据"
            ok-text="确定"
            cancel-text="取消"
            @confirm="handleDeleteOrBatchDelete(null)"
          >
            <a-button type="primary" color="error" :disabled="hasBatchDelete"> 批量删除 </a-button>
          </Popconfirm>
        </Authority>
      </template>
      <template #doDeviceSlot="{ record }">
        <a-button type="text" @click="handleDeviceView(record)">
          <span style="color: #377dff">查看设备</span>
        </a-button>
      </template>
      <template #action="{ record }">
        <TableAction
          :actions="[
            {
              label: '查看',
              icon: 'ant-design:eye-outlined',
              onClick: handleViewDetail.bind(null, record),
              ifShow: record.status === 1,
            },
            {
              label: '编辑',
              icon: 'clarity:note-edit-line',
              auth: 'api:yt:report_form:config:update',
              onClick: handleCreateOrEdit.bind(null, record),
              ifShow: record.status === 0,
            },
            {
              label: '删除',
              icon: 'ant-design:delete-outlined',
              auth: 'api:yt:report_form:config:delete',
              color: 'error',
              ifShow: record.status === 0,
              popConfirm: {
                title: '是否确认删除',
                confirm: handleDeleteOrBatchDelete.bind(null, record),
              },
            },
          ]"
        />
      </template>
      <template #configStatus="{ record }">
        <Switch
          :disabled="disabledSwitch"
          :checked="record.status === 1"
          :loading="record.pendingStatus"
          checkedChildren="启用"
          unCheckedChildren="禁用"
          @change="(checked: boolean) => statusChange(checked, record)"
        />
      </template>
    </BasicTable>
    <ReportConfigDrawer @register="registerDrawer" @success="handleSuccess" />
    <DevicePreviewModal @register="registerModal" />
  </div>
</template>

<script lang="ts" setup>
  import { reactive, nextTick, ref } from 'vue';
  import { BasicTable, useTable, TableAction } from '/@/components/Table';
  import { useDrawer } from '/@/components/Drawer';
  import ReportConfigDrawer from './ReportConfigDrawer.vue';
  import DevicePreviewModal from './DevicePreviewModal.vue';
  import {
    reportPage,
    deleteReportManage,
    putReportByidAndStatusManage,
  } from '/@/api/report/reportManager';
  import { searchFormSchema, columns } from './config.data';
  import { Authority } from '/@/components/Authority';
  import { useBatchDelete } from '/@/hooks/web/useBatchDelete';
  import { Popconfirm, Switch } from 'ant-design-vue';
  import { useModal } from '/@/components/Modal';
  import { useGo } from '/@/hooks/web/usePage';
  import { useMessage } from '/@/hooks/web/useMessage';

  const searchInfo = reactive<Recordable>({});
  const disabledSwitch = ref(false);

  const [registerTable, { reload, setProps, setSelectedRowKeys }] = useTable({
    title: '报表列表',
    api: reportPage,
    columns,
    showIndexColumn: false,
    clickToRowSelect: false,
    formConfig: {
      labelWidth: 120,
      schemas: searchFormSchema,
      fieldMapToTime: [['sendTime', ['startTime', 'endTime'], 'x']],
    },
    useSearchForm: true,
    showTableSetting: true,
    bordered: true,
    rowKey: 'id',
    actionColumn: {
      width: 200,
      title: '操作',
      dataIndex: 'action',
      slots: { customRender: 'action' },
      fixed: 'right',
    },
  });

  // 弹框
  const [registerDrawer, { openDrawer }] = useDrawer();
  const { createMessage } = useMessage();

  // 刷新
  const handleSuccess = () => {
    reload();
  };

  const { hasBatchDelete, handleDeleteOrBatchDelete, selectionOptions, resetSelectedRowKeys } =
    useBatchDelete(deleteReportManage, handleSuccess, setProps);
  selectionOptions.rowSelection.getCheckboxProps = (record: Recordable) => {
    // Demo:status为1的选择框禁用
    if (record.status === 1) {
      return { disabled: true };
    } else {
      return { disabled: false };
    }
  };

  nextTick(() => {
    setProps(selectionOptions);
  });

  // 新增或编辑
  const handleCreateOrEdit = (record: Recordable | null) => {
    if (record) {
      openDrawer(true, {
        isUpdate: true,
        record,
        isView: true,
      });
    } else {
      openDrawer(true, {
        isUpdate: false,
        isView: true,
      });
    }
  };
  const handleViewDetail = (record: Recordable) => {
    if (record) {
      openDrawer(true, {
        isUpdate: true,
        record,
        isView: false,
      });
    }
  };

  //查看设备
  const [registerModal, { openModal }] = useModal();
  const handleDeviceView = (record) => {
    openModal(true, {
      isUpdate: true,
      record,
    });
  };
  const statusChange = async (checked, record) => {
    try {
      setProps({
        loading: true,
      });
      setSelectedRowKeys([]);
      resetSelectedRowKeys();
      disabledSwitch.value = true;
      const newStatus = checked ? 1 : 0;
      const res = await putReportByidAndStatusManage(record.id, newStatus);
      if (res && newStatus) {
        createMessage.success(`启用成功`);
      } else {
        createMessage.success('禁用成功');
      }
    } finally {
      setTimeout(() => {
        setProps({
          loading: false,
        });
        disabledSwitch.value = false;
      }, 500);
      reload();
    }
  };
  const go = useGo();
</script>
